﻿Imports System.Runtime.InteropServices
Public Class GEODIB

    'Graphics File Library Extended
    '
    ' GFL library Copyright (c) 1991-2007 Pierre-e Gougelet
    ' All rights reserved
    ' Commercial use is not authorized without agreement
    '
    ' Interface for VB.NET : Christophe Vergon contact diana2d@wanadoo.fr

    Public Enum GFL_MODE
        GFL_MODE_TO_BINARY = 1
        GFL_MODE_TO_4GREY = 2
        GFL_MODE_TO_8GREY = 3
        GFL_MODE_TO_16GREY = 4
        GFL_MODE_TO_32GREY = 5
        GFL_MODE_TO_64GREY = 6
        GFL_MODE_TO_128GREY = 7
        GFL_MODE_TO_216GREY = 8
        GFL_MODE_TO_256GREY = 9
        GFL_MODE_TO_8COLORS = 12
        GFL_MODE_TO_16COLORS = 13
        GFL_MODE_TO_32COLORS = 14
        GFL_MODE_TO_64COLORS = 15
        GFL_MODE_TO_128COLORS = 16
        GFL_MODE_TO_216COLORS = 17
        GFL_MODE_TO_256COLORS = 18
        GFL_MODE_TO_RGB = 19
        GFL_MODE_TO_RGBA = 20
        GFL_MODE_TO_BGR = 21
        GFL_MODE_TO_ABGR = 22
        GFL_MODE_TO_BGRA = 23
        GFL_MODE_TO_ARGB = 24
    End Enum
    Public Enum GFL_MODE_PARAMS
        GFL_MODE_NO_DITHER = 0
        GFL_MODE_PATTERN_DITHER = 1
        GFL_MODE_HALTONE45_DITHER = 2  ' Only with GFL_MODE_TO_BINARY
        GFL_MODE_HALTONE90_DITHER = 3  ' Only with GFL_MODE_TO_BINARY
        GFL_MODE_ADAPTIVE = 4
        GFL_MODE_FLOYD_STEINBERG = 5   ' Only with GFL_MODE_TO_BINARY
    End Enum

    Structure GFL_RECT
        Public x As Integer
        Public y As Integer
        Public w As Integer
        Public h As Integer
    End Structure

    Structure GFL_POINT
        Public x As Integer
        Public y As Integer
    End Structure
    Public Const GFL_RESIZE_QUICK = 0
    Public Const GFL_RESIZE_BILINEAR = 1
    Public Const GFL_RESIZE_HERMITE = 2
    Public Const GFL_RESIZE_GAUSSIAN = 3
    Public Const GFL_RESIZE_BELL = 4
    Public Const GFL_RESIZE_BSPLINE = 5
    Public Const GFL_RESIZE_MITSHELL = 6
    Public Const GFL_RESIZE_LANCZOS = 7
    Public Enum GFL_CANVASRESIZE
        GFL_CANVASRESIZE_CENTER = 0
        GFL_CANVASRESIZE_TOPLEFT = 1
        GFL_CANVASRESIZE_TOPRIGHT = 2
        GFL_CANVASRESIZE_BOTTOMLEFT = 3
        GFL_CANVASRESIZE_BOTTOMRIGHT = 4
        GFL_CANVASRESIZE_TOP = 5
        GFL_CANVASRESIZE_BOTTOM = 6
        GFL_CANVASRESIZE_LEFT = 7
        GFL_CANVASRESIZE_RIGHT = 8
    End Enum
    Public Const GFL_IPTC_BYLINE = &H50
    Public Const GFL_IPTC_BYLINETITLE = &H55
    Public Const GFL_IPTC_CREDITS = &H6E
    Public Const GFL_IPTC_SOURCE = &H73
    Public Const GFL_IPTC_CAPTIONWRITER = &H7A
    Public Const GFL_IPTC_CAPTION = &H78
    Public Const GFL_IPTC_HEADLINE = &H69
    Public Const GFL_IPTC_SPECIALINSTRUCTIONS = &H28
    Public Const GFL_IPTC_OBJECTNAME = &H5
    Public Const GFL_IPTC_DATECREATED = &H37
    Public Const GFL_IPTC_RELEASEDATE = &H1E
    Public Const GFL_IPTC_TIMECREATED = &H3C
    Public Const GFL_IPTC_RELEASETIME = &H23
    Public Const GFL_IPTC_CITY = &H5A
    Public Const GFL_IPTC_STATE = &H5F
    Public Const GFL_IPTC_COUNTRY = &H65
    Public Const GFL_IPTC_COUNTRYCODE = &H64
    Public Const GFL_IPTC_SUBLOCATION = &H5C
    Public Const GFL_IPTC_ORIGINALTRREF = &H67
    Public Const GFL_IPTC_CATEGORY = &HF
    Public Const GFL_IPTC_COPYRIGHT = &H74
    Public Const GFL_IPTC_EDITSTATUS = &H7
    Public Const GFL_IPTC_PRIORITY = &HA
    Public Const GFL_IPTC_OBJECTCYCLE = &H4B
    Public Const GFL_IPTC_JOBID = &H16
    Public Const GFL_IPTC_PROGRAM = &H41
    Public Const GFL_IPTC_KEYWORDS = &H19
    Public Const GFL_IPTC_SUPCATEGORIES = &H14
    Public Const GFL_EXIF_MAKER = "&H010F"
    Public Const GFL_EXIF_MODEL = "&H0110"
    Public Const GFL_EXIF_ORIENTATION = "&H0112"
    Public Const GFL_EXIF_EXPOSURETIME = "&H829A"
    Public Const GFL_EXIF_FNUMBER = "&H829D"
    Public Const GFL_EXIF_DATETIME_ORIGINAL = "&H9003"
    Public Const GFL_EXIF_SHUTTERSPEED = "&H9201"
    Public Const GFL_EXIF_APERTURE = "&H9202"
    Public Const GFL_EXIF_MAXAPERTURE = "&H9205"
    Public Const GFL_EXIF_FOCALLENGTH = "&H920A"

    Public Const GFL_VERSION = "3.11"
    Public Const GFL_FALSE = 0
    Public Const GFL_TRUE = 1
    'Erreurs
    Public Enum GFL_ERROR
        GFL_NO_ERROR = 0
        GFL_ERROR_FILE_OPEN = 1
        GFL_ERROR_FILE_READ = 2
        GFL_ERROR_FILE_CREATE = 3
        GFL_ERROR_FILE_WRITE = 4
        GFL_ERROR_NO_MEMORY = 5
        GFL_ERROR_UNKNOWN_FORMAT = 6
        GFL_ERROR_BAD_BITMAP = 7
        GFL_ERROR_BAD_FORMAT_INDEX = 10
        GFL_ERROR_BAD_PARAMETERS = 50
        GFL_UNKNOWN_ERROR = 255
    End Enum
    'Origines
    Public Enum GFL_ORIGIN 'As Byte
        GFL_LEFT = &H0
        GFL_RIGHT = &H1
        GFL_TOP = &H0
        GFL_BOTTOM = &H10
        GFL_TOP_LEFT = (GFL_TOP Or GFL_LEFT)
        GFL_BOTTOM_LEFT = (GFL_BOTTOM Or GFL_LEFT)
        GFL_TOP_RIGHT = (GFL_TOP Or GFL_RIGHT)
        GFL_BOTTOM_RIGHT = (GFL_BOTTOM Or GFL_RIGHT)
    End Enum

    'structure de Compressions
    Public Enum GFL_COMPRESSION
        GFL_NO_COMPRESSION = 0
        GFL_RLE = 1
        GFL_LZW = 2
        GFL_JPEG = 3
        GFL_ZIP = 4
        GFL_SGI_RLE = 5
        GFL_CCITT_RLE = 6
        GFL_CCITT_FAX3 = 7
        GFL_CCITT_FAX3_2D = 8
        GFL_CCITT_FAX4 = 9
        GFL_WAVELET = 10
        GFL_LZW_PREDICTOR = 11
        GFL_UNKNOWN_COMPRESSION = 255
    End Enum
    Public Enum GFL_BITMAP_TYPE 'As Short
        GFL_BINARY = &H1
        GFL_GREY = &H2
        GFL_COLORS = &H4
        GFL_RGB = &H10
        GFL_RGBA = &H20
        GFL_BGR = &H40
        GFL_ABGR = &H80
        GFL_BGRA = &H100
        GFL_ARGB = &H200
        GFL_CMYK = &H400
    End Enum
    Public Structure GFL_COLOR
        Public Red As Integer
        Public Green As Integer
        Public Blue As Integer
        Public Alpha As Integer
    End Structure




    'Ordre des cannaux
    Public Enum GFL_CORDER
        GFL_CORDER_INTERLEAVED = 0
        GFL_CORDER_SEQUENTIAL = 1
        GFL_CORDER_SEPARATE = 2
    End Enum

    'structure de cannaux
    Public Enum GFL_CTYPE
        GFL_CTYPE_GREYSCALE = 0
        GFL_CTYPE_RGB = 1
        GFL_CTYPE_BGR = 2
        GFL_CTYPE_RGBA = 3
        GFL_CTYPE_ABGR = 4
        GFL_CTYPE_CMY = 5
        GFL_CTYPE_CMYK = 6
    End Enum

    'Load_Params Flags
    Public Const GFL_LOAD_SKIP_ALPHA = &H1
    Public Const GFL_LOAD_IGNORE_READ_ERROR = &H2
    Public Const GFL_LOAD_BY_EXTENSION_ONLY = &H4
    Public Const GFL_LOAD_READ_ALL_COMMENT = &H8
    Public Const GFL_LOAD_FORCE_COLOR_MODEL = &H10
    Public Const GFL_LOAD_PREVIEW_NO_CANVAS_RESIZE = &H20
    Public Const GFL_LOAD_BINARY_AS_GREY = &H40
    Public Const GFL_LOAD_ORIGINAL_COLORMODEL = &H40
    Public Const GFL_LOAD_ONLY_FIRST_FRAME = &H100
    Public Const GFL_LOAD_ORIGINAL_DEPTH = &H200
    Public Const GFL_LOAD_METADATA = &H400
    Public Const GFL_LOAD_COMMENT = &H800
    Public Const GFL_LOAD_HIGH_QUALITY_THUMBNAIL = &H1000

    Public Const GFL_SAVE_REPLACE_EXTENSION = &H1
    Public Const GFL_SAVE_WANT_FILENAME = &H2
    Public Const GFL_SAVE_ANYWAY = &H4

    Public Enum GFL_COLORMODEL
        GFL_CM_RGB = 0
        GFL_CM_GREY = 1
        GFL_CM_CMY = 2
        GFL_CM_CMYK = 3
        GFL_CM_YCBCR = 4
        GFL_CM_YUV16 = 5
        GFL_CM_LAB = 6
        GFL_CM_LOGLUV = 7
        GFL_CM_LOGL = 8
    End Enum


    <StructLayout(LayoutKind.Explicit)> Public Structure BITMAPINFOHEADER
        <FieldOffset(0)> Public biSize As Int32
        <FieldOffset(4)> Public biWidth As Int32
        <FieldOffset(8)> Public biHeight As Int32
        <FieldOffset(12)> Public biPlanes As Int16
        <FieldOffset(14)> Public biBitCount As Int16
        <FieldOffset(16)> Public biCompression As Int32
        <FieldOffset(20)> Public biSizeImage As Int32
        <FieldOffset(24)> Public biXPelsperMeter As Int32
        <FieldOffset(28)> Public biYPelsPerMeter As Int32
        <FieldOffset(32)> Public biClrUsed As Int32
        <FieldOffset(36)> Public biClrImportant As Int32
    End Structure

    <StructLayout(LayoutKind.Sequential)> Public Structure RGBQUAD
        Public rgbBlue As Byte
        Public rgbGreen As Byte
        Public rgbRed As Byte
        Public rgbReserved As Byte
    End Structure

    <StructLayout(LayoutKind.Sequential)> Public Structure BITMAPINFO
        Public bmiHeader As BITMAPINFOHEADER
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=256)> Public bmiColors() As RGBQUAD
    End Structure

    'Load Params Struct
    Public Structure GFL_LOAD_PARAMS
        Public Flags As Integer
        Public FormatIndex As Integer ' -1 pour détection automatique
        Public ImageWanted As Integer
        Public Origin As Short
        Public ColorModel As Short
        Public LinePadding As Integer
        Public DefaultAlpha As Byte
        Public PsdNoAlphaForNonLayer As Byte
        Public PngComposeWithAlpha As Byte
        Public WMFHighResolution As Byte
        Public Width As Integer
        Public Height As Integer
        Public Offset As Integer
        Public ChannelOrder As Short
        Public ChannelType As Short
        Public PcdBase As Short
        Public EpsDpi As Short
        Public EpsWidth As Integer
        Public EpsHeight As Integer
        Public LutType As Short
        Public CompressRation As Short
        Public MaxFileSize As Integer
        Public LutData As Integer
        Public LutFilename As Integer

        Public CameraRawUseAutomaticBalance As Byte
        Public CameraRawUseCameraBalance As Byte
        Public Reserved4 As Short
        Public CameraRawGamma As Integer
        Public CameraRawBrightness As Integer
        Public CameraRawRedScaling As Integer
        Public CameraRawBlueScaling As Integer
        Public CameraRawFilterDomain As Integer
        Public CameraRawFilterRange As Integer

        Public Callbacks As LOAD_CALLBACK_STRUCT
        Public UserParams As Integer
    End Structure
    Public Structure LOAD_CALLBACK_STRUCT
        Public Read As Integer
        Public Tell As Integer
        Public Seek As Integer

        Public AllocateBitmap As Integer
        Public AllocateBitmapParams As Integer
        Public Progress As Integer
        Public ProgressParams As Integer
        Public WantCancel As Integer
        Public WantCancelParams As Integer
    End Structure

    Public Structure SAVE_CALLBACK_STRUCT
        Public Write As Integer
        Public Tell As Integer
        Public Seek As Integer
        Public GetLine As Integer
        Public GetLineParams As Integer
    End Structure
    <StructLayout(LayoutKind.Sequential)> Public Structure GFL_FILE_INFORMATION
        Public structure1 As Short
        Public Origin As Short
        Public Width As Integer
        Public Height As Integer
        Public FormatIndex As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> Public FormatName As String
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> Public Description As String
        Public Xdpi As Short
        Public Ydpi As Short
        Public BitsPerComponent As Short
        Public ComponentsPerPixel As Short
        Public NumberOfImages As Integer
        Public FileSize As Integer
        Public ColorModel As Short
        Public Compression As Short
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> Public CompressionDescription As String
        Public XOffset As Integer
        Public YOffset As Integer
        Public ExtraInfos As Integer

    End Structure
    Public Structure GFL_SAVE_PARAMS
        Public Flags As Integer
        Public FormatIndex As Integer
        Public Compression As Short
        Public Quality As Short
        Public CompressionLevel As Short
        Public Interlaced As Byte
        Public Progressive As Byte
        Public OptimizeHuffmanTable As Byte
        Public InAscii As Byte
        Public LutType As Short
        Public Reserved As Short
        Public LutData As Integer
        Public LutFilename As Integer
        Public Offset As Integer
        Public ChannelOrder As Short
        Public ChannelType As Short
        Public Callbacks As SAVE_CALLBACK_STRUCT
        Public UserParams As Integer
    End Structure
    Public Const GFL_READ = &H1
    Public Const GFL_WRITE = &H2

    'Format Information Scruct
    Public Structure GFL_FORMAT_INFORMATION
        Public Index As Integer
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=8)> Public Name As String
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> Public Description As String
        Public Status As Integer
        Public NumberOfExtension As Integer
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=8)> Public Extension() As String
    End Structure

    Private Const BI_RGB = 0
    Private Const CBM_INIT = &H4
    Private Const DIB_RGB_COLORS = 0
    Private Const SRCCOPY = &HCC0020
    Private Const SRCAND = &H8800C6
    Private Const STRETCH_DELETESCANS = 3
    Private Const STRETCH_ANDSCANS = 1


    '**********************************************

    '******************************************GFLSDK testées OK*********************************************************************************************
    Private Declare Function gflLibraryInit Lib "libgfl311.dll" () As Integer
    Private Declare Sub gflLibraryExit Lib "libgfl311.dll" ()
    Private Declare Auto Function gflGetFormatIndexByName Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String) As Integer
    Private Declare Auto Function gflGetFormatNameByIndex Lib "libgfl311.dll" (ByVal Index As Integer) As <MarshalAs(UnmanagedType.LPStr)> String
    Private Declare Function gflLoadBitmap Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal filename As String, ByRef BITMAP As Integer, ByRef params As GFL_LOAD_PARAMS, ByRef t As GFL_FILE_INFORMATION) As Integer
    Private Declare Function gflResize Lib "libgfl311.dll" (ByVal src As IntPtr, ByRef Dst As GFL_BITMAP, ByVal Width As Integer, ByVal Height As Integer, ByVal method As UInteger, ByVal Flags As UInteger) As Integer
    Private Declare Sub gflGetDefaultLoadParams Lib "libgfl311.dll" (ByRef params As GFL_LOAD_PARAMS)
    Private Declare Sub gflGetDefaultSaveParams Lib "libgfl311.dll" (ByRef params As GFL_SAVE_PARAMS)
    Private Declare Sub gflFreeBitmapData Lib "libgfl311.dll" (ByRef BITMAP As IntPtr)
    Private Declare Function gflSaveBitmap Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal filename As String, ByVal BITMAP As GFL_BITMAP, ByRef params As GFL_SAVE_PARAMS) As Integer
    Public Declare Function gflRotateFine Lib "libgfl311.dll" (ByVal src As GFL_BITMAP, ByRef dest As GFL_BITMAP, ByVal angle As Double, ByRef Color As GFL_COLOR) As Integer

    '***************************************GFLSDK non testées********************************************************************************

    Public Declare Function gflMemoryAlloc Lib "libgfl311.dll" (ByVal Size As Integer) As Integer
    Public Declare Function gflMemoryRealloc Lib "libgfl311.dll" (ByVal Ptr As Integer, ByVal Size As Integer) As Integer
    Public Declare Sub gflMemoryFree Lib "libgfl311.dll" (ByVal Ptr As Integer)

    Public Declare Function gflGetVersion Lib "libgfl311.dll" () As Integer
    Public Declare Function gflGetVersionOfLibformat Lib "libgfl311.dll" () As Integer
    Public Declare Function gflGetNumberOfFormat Lib "libgfl311.dll" () As Integer

    Public Declare Sub gflEnableLZW Lib "libgfl311.dll" (ByVal Enable As Byte)
    Public Declare Sub gflSetPluginsPathname Lib "libgfl311.dll" (ByVal Path As String)

    Public Declare Function gflFormatIsSupported Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String) As Byte
    Public Declare Function gflFormatIsWritableByIndex Lib "libgfl311.dll" (ByVal Index As Integer) As Byte
    Public Declare Function gflFormatIsWritableByName Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String) As Byte
    Public Declare Function gflFormatIsReadableByIndex Lib "libgfl311.dll" (ByVal Index As Integer) As Byte
    Public Declare Function gflFormatIsReadableByName Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String) As Byte
    Public Declare Function gflGetDefaultFormatSuffixByIndex Lib "libgfl311.dll" (ByVal Index As Integer) As Integer
    Public Declare Function gflGetDefaultFormatSuffixByName Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String) As Integer
    Public Declare Function gflGetFormatDescriptionByIndex Lib "libgfl311.dll" (ByVal Index As Integer) As Integer
    Public Declare Function gflGetFormatDescriptionByName Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String) As Integer
    Public Declare Function gflGetFormatInformationByName Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal Name As String, ByRef info As GFL_FORMAT_INFORMATION) As Integer
    Public Declare Function gflGetFormatInformationByIndex Lib "libgfl311.dll" (ByVal Index As Integer, ByRef info As GFL_FORMAT_INFORMATION) As Integer

    Public Declare Function gflGetErrorString Lib "libgfl311.dll" (ByVal Error1 As Integer) As <MarshalAs(UnmanagedType.LPStr)> String
    Public Declare Function gflGetLabelForColorModel Lib "libgfl311.dll" (ByVal color_model As Integer) As Integer
    Public Declare Function gflGetFileInformation Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal filename As String, ByVal Index As Integer, ByRef info As GFL_FILE_INFORMATION) As Integer
    Public Declare Sub gflFreeFileInformation Lib "libgfl311.dll" (ByRef info As GFL_FILE_INFORMATION)
    Public Declare Sub gflGetDefaultPreviewParams Lib "libgfl311.dll" (ByRef params As GFL_LOAD_PARAMS)
    Public Declare Function gflLoadPreview Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal filename As String, ByVal Width As Integer, ByVal Height As Integer, ByRef BITMAP As IntPtr, ByRef params As GFL_LOAD_PARAMS, ByRef info As GFL_FILE_INFORMATION) As Integer


    Public Declare Function gflSaveBitmapIntoHandle Lib "libgfl311.dll" (ByVal Handle As Integer, ByRef BITMAP As GFL_BITMAP, ByRef params As GFL_SAVE_PARAMS) As Integer
    Public Declare Function gflLoadPreviewFromHandle Lib "libgfl311.dll" (ByVal Handle As Integer, ByVal Width As Integer, ByVal Height As Integer, ByRef BITMAP As Integer, ByRef params As GFL_LOAD_PARAMS, ByRef info As GFL_FILE_INFORMATION) As Integer
    Public Declare Function gflLoadBitmapFromHandle Lib "libgfl311.dll" (ByVal Handle As Integer, ByRef BITMAP As Integer, ByRef info As GFL_LOAD_PARAMS, ByRef info As GFL_FILE_INFORMATION) As Integer

    Public Declare Function gflFileCreate Lib "libgfl311.dll" (ByRef Handle As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal filename As String, ByVal image_count As Integer, ByRef params As GFL_SAVE_PARAMS) As Integer
    Public Declare Function gflFileAddPicture Lib "libgfl311.dll" (ByVal Handle As Integer, ByRef BITMAP As GFL_BITMAP) As Integer
    Public Declare Sub gflFileClose Lib "libgfl311.dll" (ByVal Handle As Integer)

    Public Declare Function gflCloneBitmap Lib "libgfl311.dll" (ByRef BITMAP As GFL_BITMAP) As IntPtr
    Public Declare Function gflAllockBitmap Lib "libgfl311.dll" (ByVal bmptype As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal Line_padding As Integer, ByRef Color As GFL_COLOR) As Integer
    Public Declare Sub gflFreeBitmap Lib "libgfl311.dll" (ByRef BITMAP As GFL_BITMAP)
    Public Declare Sub gflFreeBitmapLong Lib "libgfl311.dll" Alias "gflFreeBitmap" (ByVal BITMAP As Integer)
    Public Declare Sub gflFreeBitmapDataLong Lib "libgfl311.dll" Alias "gflFreeBitmapData" (ByVal BITMAP As Integer)

    Public Declare Function gflLoadBitmapFromMemory Lib "libgfl311.dll" (ByRef data As Byte, ByVal dat_length As Integer, ByRef BITMAP As Integer, ByRef params As GFL_LOAD_PARAMS, ByRef info As GFL_FILE_INFORMATION) As Integer
    Public Declare Function gflLoadEXIF Lib "libgfl311.dll" (<MarshalAs(UnmanagedType.LPStr)> ByVal FileName As String, ByVal Flags As Integer) As Integer

    Public Declare Function gflSetColorAt Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByVal x As Integer, ByVal y As Integer, ByRef Color As GFL_COLOR) As Integer
    Public Declare Function gflGetColorAt Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByVal x As Integer, ByVal y As Integer, ByRef Color As GFL_COLOR) As Integer
    Public Declare Function gflChangeColorDepth Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer, ByVal Mode As GFL_MODE, ByVal params As GFL_MODE_PARAMS) As Integer

    Public Declare Function gflReplaceColor Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer, ByRef Color As GFL_COLOR, ByRef new_color As GFL_COLOR, ByVal Tolerance As Integer) As Integer

    Public Declare Function gflFlipVertical Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer) As Integer
    Public Declare Function gflFlipHorizontal Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer) As Integer
    Public Declare Function gflCrop Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer, ByRef Rect As GFL_RECT) As Integer

    Public Declare Function gflResizeCanvas Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal Mode As GFL_CANVASRESIZE, ByRef Color As GFL_COLOR) As Integer
    Public Declare Function gflRotate Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer, ByVal angle As Integer, ByRef Color As GFL_COLOR) As Integer

    Public Declare Function gflBitblt Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Rect As GFL_RECT, ByRef Dst As GFL_BITMAP, ByVal x_dest As Integer, ByVal y_dest As Integer) As Integer
    Public Declare Function gflBitbltEx Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Rect As GFL_RECT, ByRef Dst As GFL_BITMAP, ByVal x_dest As Integer, ByVal y_dest As Integer) As Integer
    Public Declare Function gflAutoCrop Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByRef Dst As Integer, ByRef Color As GFL_COLOR, ByVal Tolerance As Integer) As Integer
    Public Declare Function gflMerge Lib "libgfl311.dll" (ByRef src As Integer, ByRef Origin As GFL_POINT, ByRef Opacity As Integer, ByVal num_bitmap As Integer, ByRef Dst As Integer) As Integer


    Public Declare Function gflBitmapGetIPTCValue Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByVal id As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal Name As String, ByVal value_length As Integer) As Integer
    Public Declare Function gflBitmapGetEXIFValue Lib "libgfl311.dll" (ByRef src As GFL_BITMAP, ByVal tag As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal Name As String, ByVal value_length As Integer) As Integer

    '**********************************************************************************************************************************************



    '*******************************************GDI32**********************************************************************************************
    Private Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As IntPtr, ByVal x As Integer, ByVal y As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal SrcX As Integer, ByVal SrcY As Integer, ByVal wSrcWidth As Integer, ByVal wSrcHeight As Integer, ByVal lpBits As IntPtr, ByRef lpBitsInfo As BITMAPINFO, ByVal wUsage As UInteger, ByVal dwRop As UInteger) As Integer
    Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As IntPtr, ByVal nStretchMode As Integer) As Integer
    Private Declare Function SetMapMode Lib "gdi32" (ByVal hdc As Integer, ByVal nMapMode As Integer) As Integer

    Private ptr As IntPtr
    Private GFL As GFL_BITMAP

    Private mChemin As String
    Public Property Chemin() As String
        Get
            Return mChemin
        End Get
        Set(ByVal value As String)
            mChemin = value
        End Set
    End Property


    Private mNomFichier As String
    Public Property Nomfichier() As String
        Get
            Return mNomFichier
        End Get
        Set(ByVal value As String)
            mNomFichier = value
        End Set
    End Property


    Private mExtention As String
    Public Property Extention() As String
        Get
            Return mExtention
        End Get
        Set(ByVal value As String)
            mExtention = value
        End Set
    End Property

    Public Sub New(ByVal chemin As String, ByVal Nomfichier As String, ByVal extention As String)


        mChemin = chemin
        mNomFichier = Nomfichier
        mExtention = extention

    End Sub

    Public Function scanalign(ByVal pwidth&) As Integer
        scanalign = (pwidth& + 3) And &HFFFFFFFC
    End Function

    Public Function byteperscanline(ByVal pwidth&, ByVal bitcount&) As Integer
        Select Case bitcount&
            Case 1
                byteperscanline = scanalign((pwidth& + 7) \ 8)
            Case 4
                byteperscanline = scanalign((pwidth& + 1) \ 2)
            Case 8
                byteperscanline = scanalign(pwidth&)
            Case 24
                byteperscanline = scanalign(pwidth& * 3)
            Case 32
                'byteperscanline
        End Select
    End Function

    Public Function extGetDIBFromBitmap() As BITMAPINFO
        Dim DibInfo As BITMAPINFO = Nothing
        Dim ColorMap As New GFL_COLORMAP
        Dim Ind As Integer


        With DibInfo.bmiHeader
            .biSize = Marshal.SizeOf(DibInfo.bmiHeader) 'La taille de la structure
            .biWidth = GFL.Width 'Largeur du bitmap
            .biHeight = GFL.Height 'Hauteur du bitmap
            .biPlanes = 1 'Nombre de plans
            .biCompression = BI_RGB 'Toujours BI_RGB
            .biClrImportant = 0 'Toujours 0

            If GFL.Xdpi = GFL.Ydpi Then
                If GFL.Xdpi <> 0 Then

                    .biXPelsperMeter = CLng(GFL.Xdpi / 25.4 * 1000)
                    .biYPelsPerMeter = CLng(GFL.Ydpi / 25.4 * 1000)

                Else
                    .biXPelsperMeter = 100
                    .biYPelsPerMeter = 100

                End If
            Else
                .biXPelsperMeter = CLng(GFL.Xdpi / 25.4 * 1000)
                .biYPelsPerMeter = CLng(GFL.Ydpi / 25.4 * 1000)

            End If

        End With

        With DibInfo
            Select Case GFL.Type

                Case 1
                    .bmiHeader.biBitCount = 1
                    .bmiHeader.biSizeImage = byteperscanline(GFL.Width, 1) * GFL.Height
                    .bmiHeader.biClrUsed = 2
                Case 2, 4

                    .bmiHeader.biBitCount = 8
                    .bmiHeader.biSizeImage = byteperscanline(GFL.Width, 8) * GFL.Height
                    .bmiHeader.biClrUsed = 0
                Case 64, 10
                    .bmiHeader.biBitCount = 24
                    .bmiHeader.biSizeImage = byteperscanline(GFL.Width, 24) * GFL.Height
                    .bmiHeader.biClrUsed = 0
            End Select

            Select Case GFL.Type 'Suivant le type de bitmap
                Case GFL_BITMAP_TYPE.GFL_COLORS 'Si GFL_COLORS (une palette de couleurs indexé de 0 à 255)
                    Marshal.Copy(GFL.ColorMap, ColorMap.Red, 0, 256)
                    Marshal.Copy(GFL.ColorMap + 256, ColorMap.Green, 0, 256)
                    Marshal.Copy(GFL.ColorMap + 2 * 256, ColorMap.Blue, 0, 256)
                    ReDim .bmiColors(255)
                    For Ind = 0 To 255 'Pour chaque index on indique à la structure Dib_Info
                        .bmiColors(Ind).rgbBlue = ColorMap.Blue(Ind) 'La valeur du bleu
                        .bmiColors(Ind).rgbGreen = ColorMap.Green(Ind) 'La valeur du vert
                        .bmiColors(Ind).rgbRed = ColorMap.Red(Ind) 'La valeur du rouge
                    Next Ind
                Case GFL_BITMAP_TYPE.GFL_BINARY 'Si GFL_BINARY (seulement noir et blanc donc 2 couleurs indexés) on indique à Dib_Info qu'il y a deux index
                    ReDim .bmiColors(255)
                    .bmiColors(0).rgbBlue = 0 : .bmiColors(0).rgbGreen = 0 : .bmiColors(0).rgbRed = 0 'Le premier vaut Red=0,Green=0,Blue=0 donc du noir (#000000)
                    .bmiColors(1).rgbBlue = 255 : .bmiColors(1).rgbGreen = 255 : .bmiColors(1).rgbRed = 255 'Le second vaut Red=255,Green=255,Blue=255 donc blanc (#FFFFFF)
                Case GFL_BITMAP_TYPE.GFL_GREY 'Si GFL_GREY (On travaille sur 256 nuances)
                    ReDim .bmiColors(255)
                    For Ind = 0 To 255 'Pour chaque index de Dib_Info on indique une nuance de gris
                        .bmiColors(Ind).rgbBlue = Ind  ' Il y a 256 index et 256 gris on donne à chaque index
                        .bmiColors(Ind).rgbGreen = Ind ' et pour chaque canaux la valeur de la nuance
                        .bmiColors(Ind).rgbRed = Ind
                    Next Ind
            End Select
        End With
        extGetDIBFromBitmap = DibInfo

    End Function

    Public Sub ChargeImage()
        Dim GflParams As GFL_LOAD_PARAMS = Nothing
        Dim GflInfo As GFL_FILE_INFORMATION = Nothing
        Dim Error1 As Integer = 0


        gflLibraryInit()
        gflGetDefaultLoadParams(GflParams)

        With GflParams
            .Flags = GFL_LOAD_SKIP_ALPHA Or GFL_LOAD_BY_EXTENSION_ONLY
            .FormatIndex = -1
            .Origin = GFL_ORIGIN.GFL_BOTTOM_LEFT
            .ColorModel = GFL_BITMAP_TYPE.GFL_BGR 'Component order like DIB
            .LinePadding = 4 'Line padding on 4 bytes (32bits Windows)
        End With


        Dim f As String = mChemin & mNomFichier & "." & mExtention

        Error1 = gflLoadBitmap(f, ptr, GflParams, GflInfo)

        If GFL Is Nothing Then
            GFL = New GFL_BITMAP
        End If
        'transfert du pointeur vers la classe GFL_BITMAP
        ' On peut aussi déclarer gfloadbitmap en passant directement une classe GFL_Bitmap byref pour avoir **GFL_Bitmap
        'dans ce cas pas de pointeur ptr mais pour libérer les ressources ça pose un pb

        Marshal.PtrToStructure(ptr, GFL)

        gflLibraryExit()
    End Sub
    Public Sub Enregistre(ByVal nomcomplet As String, ByVal nomformat As String, ByVal compression As GFL_COMPRESSION)
        Dim gflsave As GFL_SAVE_PARAMS = Nothing
        gflLibraryInit()
        gflGetDefaultSaveParams(gflsave)
        gflsave.Flags = GFL_SAVE_REPLACE_EXTENSION
        gflsave.FormatIndex = gflGetFormatIndexByName(nomformat)
        gflsave.Compression = compression
        Dim error1 = gflSaveBitmap(nomcomplet, GFL, gflsave)

        gflLibraryExit()

    End Sub
    Public Sub Enregistre(ByVal nomcomplet As String, ByVal formatindex As Integer, ByVal compression As GFL_COMPRESSION)
        Dim gflsave As GFL_SAVE_PARAMS = Nothing
        gflLibraryInit()
        gflGetDefaultSaveParams(gflsave)
        gflsave.Flags = GFL_SAVE_REPLACE_EXTENSION
        gflsave.FormatIndex = formatindex
        gflsave.Compression = compression
        Dim error1 = gflSaveBitmap(nomcomplet, GFL, gflsave)

        gflLibraryExit()

    End Sub
    Public Sub LibereImage()
        'attention déclarer une variable locale car gflfreeBitmapData agit sur la valeur de ptr
        ' donc exception en code managé

        Dim ptr1 As Integer = ptr
        gflLibraryInit()
        gflFreeBitmapData(ptr1)
        gflLibraryExit()
    End Sub

    Public Sub affiche(ByVal G As Graphics)
        Dim mbinfo As BITMAPINFO
        Dim oldmode As Integer = 0

        mbinfo = extGetDIBFromBitmap()
        Dim mhdc As IntPtr = G.GetHdc
        SetMapMode(mhdc, 1)

        If mbinfo.bmiHeader.biBitCount = 1 Then
            oldmode = SetStretchBltMode(mhdc, STRETCH_ANDSCANS)
        Else
            oldmode = SetStretchBltMode(mhdc, STRETCH_DELETESCANS)
        End If

        StretchDIBits(mhdc, 0, 0, GFL.Width / 10, GFL.Height / 10, 0, 0, GFL.Width, GFL.Height, GFL.Data, mbinfo, DIB_RGB_COLORS, SRCAND)
        oldmode = SetStretchBltMode(mhdc, oldmode)
        G.ReleaseHdc()
    End Sub
    Public Sub Rotation(ByVal angle As Double)
        Dim back As GFL_COLOR
        back.Green = 255
        back.Red = 255
        back.Blue = 255

        Dim error1 = gflRotateFine(GFL, GFL, angle, back)

    End Sub

    Public Sub retaille(ByVal n As Integer)
        Dim error1 = gflResize(ptr, GFL, GFL.Width \ n, GFL.Height \ n, GFL_RESIZE_BILINEAR, 0)
    End Sub
    Protected Overrides Sub Finalize()
        LibereImage()
        MyBase.Finalize()
    End Sub
End Class
